on startMovie
  global gMyInitColorDepth, gMyInitSoundLevel, loopMode, loopFr
  set gMyInitColorDepth to the colorDepth
  set gMyInitSoundLevel to the soundLevel
  set loopMode to 0
  if the shiftDown then
    set loopMode to 1
  end if
  if the optionDown then
    set the colorDepth to 8
    setBdrop()
    return 
  end if
  set the colorDepth to 16
  if the colorDepth <> 16 then
    setColor32()
  end if
  setBdrop()
end

on setBdrop
  global bdrop
  if the machineType = 256 then
    return 
  end if
  if not objectp(bdrop) then
    set bdrop to Backdrop(mnew)
    bdrop(mSetColor, 255)
    bdrop(mShow)
  end if
end

on setTimer sec
  set the timeoutScript to "goNext"
  set the timeoutLength to sec * 60
end

on goNext
  go(marker(1))
  set the timeoutScript to EMPTY
end

on setStart
  set the keyDownScript to "doCommandKey"
end

on goAfter
  set the timeoutScript to EMPTY
  if the colorDepth > 8 then
    go("start16")
  else
    go("start8")
  end if
end

on setColor32
  global gMyInitColorDepth
  if the machineType = 256 then
    return 
  end if
  set the colorDepth to 32
  if (the colorDepth = 32) and (the freeBytes < 3400000) then
    alert("Votre moniteur ne permet pas l'affichage en milliers de couleurs, l'application va se lancer en 256 couleurs. Si vous voulez un affichage en millions de couleurs, libérez de la mémoire en désactivant des extensions du système.")
    set the colorDepth to 8
  else
    if (the colorDepth = 32) and (the freeBytes < 4200000) then
      alert("Votre moniteur ne permet pas l'affichage en milliers de couleurs. Le programme va se lancer en millions de couleurs. Si vous rencontrez des problèmes d'affichage, libérez de la mémoire en désactivant des extensions du système.")
    end if
  end if
end

on doCommandKey
  global gMyInitSoundLevel
  if (the key > -1) and (the key < 8) then
    set the soundLevel to charToNum(the key) - 48
    return 
  end if
  if (the commandDown and (the key = "q")) or ((charToNum(the key) = 27) and (the machineType = 256)) then
    quitDemo()
  end if
end

on setWMovie s
  global mTime, mMovie
  set it to the castNum of sprite s
  set mTime to the duration of cast it
  set mMovie to s
end

on waitMovie
  global mTime, mMovie
  return the movieTime of sprite mMovie < mTime
end

on quitDemo
  global gMyInitSoundLevel, gMyInitColorDepth
  set the soundLevel to gMyInitSoundLevel
  if the machineType <> 256 then
    set the colorDepth to gMyInitColorDepth
  end if
  quit()
end
